<?php
$joomla_configuration_file = '../../../configuration.php';
require($joomla_configuration_file);
require('./Sql.php');
$jc = new JConfig;

$db_prefix = $jc->dbprefix;
$sql = new Sql($jc->host, $jc->user, $jc->password, $jc->db);

function getKeywords($keywords) {
	if($keywords) {
		$keyword_list = explode(',', $keywords);
		$tags = array();
		foreach($keyword_list as $key) if(trim($key)) array_push($tags, trim($key)); // Remove the spaces in the beginning and end.
		
		if($tags) return $tags;
	}
	return array();
}

// Get all the data in one go(except the comments).
$sections	= $sql->getById("SELECT id, title FROM ${db_prefix}sections");
$categories	= $sql->getById("SELECT ${db_prefix}categories.id, ${db_prefix}categories.title, ${db_prefix}categories.section FROM ${db_prefix}categories, ${db_prefix}sections WHERE ${db_prefix}sections.id = ${db_prefix}categories.section");
$authors	= $sql->getById("SELECT id, username FROM ${db_prefix}users");
$posts		= $sql->getAll("SELECT id,title, introtext, `fulltext`, sectionid, created, created_by, catid, state, metakey FROM ${db_prefix}content");
$tables		= $sql->getCol("SHOW TABLES");

$tags = array();
foreach($posts as $content) {
	$tags = array_merge($tags, getKeywords($content['metakey']));
}
$tags = array_values(array_unique($tags));

header("Content-type:text/octect-stream");
header("Content-Disposition:attachment;filename=Posts.xml");


print '<?xml'; ?> version="1.0" encoding="UTF-8"?>
<!-- To import this information into a WordPress blog follow these steps. -->
<!-- 1. Log into that blog as an administrator. -->
<!-- 2. Go to Tools: Import in the blog's admin panels (or Manage: Import in older versions of WordPress). -->
<!-- 3. Choose "WordPress" from the list. -->
<!-- 4. Upload this file using the form provided on that page. -->
<!-- 5. You will first be asked to map the authors in this export file to users -->
<!--    on the blog.  For each author, you may choose to map to an -->
<!--    existing user on the blog or to create a new user -->
<!-- 6. WordPress will then import each of the posts, comments, and categories -->
<!--    contained in this file into your blog -->

<!-- generator="Mambo to WordPress Converter" created="<?php echo date('Y-m-d H:i:s')?>"-->
<rss version="2.0"
	xmlns:excerpt="http://wordpress.org/export/1.0/excerpt/"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:wp="http://wordpress.org/export/1.0/"
>

<channel>
	<title><?php echo $jc->sitename?></title>
	<link><?php echo $jc->live_site?></link>
	<description><?php echo $jc->MetaDesc?></description>
	<pubDate><?php echo date('r')?></pubDate>
	<generator>http://www.bin-co.com/tools/wordpress/others/joomla_wordpress_convertor/</generator>
	<language><?php echo $jc->lang?></language>
	<wp:wxr_version>1.0</wp:wxr_version>
	<wp:base_site_url><?php echo $jc->live_site?></wp:base_site_url>
	<wp:base_blog_url><?php echo $jc->live_site?></wp:base_blog_url>
	
	<?php
	$all_slugs = array();
	foreach($sections as $id=>$title) {
		$slug = unformat($title);
		array_push($all_slugs, $slug); // This will avoid duplication.
		print "	<wp:category><wp:category_nicename>$slug</wp:category_nicename>";
		print "<wp:category_parent></wp:category_parent>";
		print "<wp:cat_name><![CDATA[$title]]></wp:cat_name></wp:category>\n";
	}
	
	foreach($categories as $category_details) {
		extract($category_details);
		$slug = unformat($title);
		if(!in_array($slug, $all_slugs)) {
			$parent_section = '';
			if(isset($sections[$section])) $parent_section = $sections[$section]; //Get the parent section of the current category.
			
			print "	<wp:category><wp:category_nicename>$slug</wp:category_nicename>";
			print "<wp:category_parent>$parent_section</wp:category_parent>";
			print "<wp:cat_name><![CDATA[$title]]></wp:cat_name></wp:category>\n";
		}
	}
	
	foreach($tags as $tag) {
		$slug = unformat($tag);
		print "	<wp:tag><wp:tag_slug>$slug</wp:tag_slug><wp:tag_name><![CDATA[$tag]]></wp:tag_name></wp:tag>";
	}

	$all_post_slugs = array();
	foreach($posts as $post) {
		extract($post);
		$slug = unformat($title);
		
		//Make sure there is no slug duplication.
		if(in_array($slug, $all_post_slugs)) {
			if(preg_match('/(\d+)$/', $slug, $matches)) { //If there is a number in the slug, add 1 to it
				$slug = preg_replace("/$matches[1]$/", $matches[1]+1);
			} else {
				$slug = $slug .= '-2'; //Or append a '-2' at the end of the slug - showing that its the second post by this name.
			}
		}
		array_push($all_post_slugs, $slug);
	?>
	
	<item>
		<title><?php echo $title?></title>
		<link><?php echo $jc->live_site . '/' . $slug ?>/</link>
		<pubDate><?php echo date('r', strtotime($created))?></pubDate>
		<dc:creator><![CDATA[<?php echo $authors[$created_by]?>]]></dc:creator>
		<category><![CDATA[<?php echo $sections[$sectionid]?>]]></category>
		<?php if($categories[$catid]['title'] != $sections[$sectionid]) { ?>
		<category><![CDATA[<?php echo $categories[$catid]['title']?>]]></category>
		<?php } ?>
		<category domain="category" nicename="<?php echo unformat($sections[$sectionid])?>"><![CDATA[<?php echo $sections[$sectionid]?>]]></category>
		<?php
		$tags = getKeywords($metakey);
		if($tags) {
			foreach($tags as $tag) { ?>
		<category domain="tag"><![CDATA[<?php echo $tag?>]]></category>
		<category domain="tag" nicename="<?php echo unformat($tag)?>"><![CDATA[<?php echo $tag?>]]></category>
		<?php }
		}?>
		<guid isPermaLink="false"><?php echo $jc->live_site . '/' . $slug ?>/</guid>
		<description></description>
		<content:encoded><![CDATA[<?php echo $fulltext?>]]></content:encoded>
		<excerpt:encoded><![CDATA[<?php echo $introtext?>]]></excerpt:encoded>
		<wp:post_date><?php echo date('Y-m-d H:i:s', strtotime($created))?></wp:post_date>
		<wp:post_date_gmt>0000-00-00 00:00:00</wp:post_date_gmt>
		<wp:comment_status>open</wp:comment_status>
		<wp:ping_status>open</wp:ping_status>
		<wp:post_name><?php echo unformat($title)?></wp:post_name>
		<wp:status><?php echo  ($state == 0) ? 'draft' : 'publish' ?></wp:status>
		<wp:post_type>post</wp:post_type>
		
		<?php
		$post_comments = false;
		
		if(in_array($db_prefix . 'comments', $tables)) $post_comments = $sql->getAll("SELECT ip, name, comments, startdate FROM ${db_prefix}comment WHERE published=1 AND articleid=$id");
		if($post_comments) {
		?>
		<wp:comment>
			<?php foreach($post_comments as $comment) { 
				extract($comment);
				$email = '';
				if($name == 'GUEST') $name = 'Anonymous';
				else extract($sql->getAssoc("SELECT name, email FROM ${db_prefix}users WHERE username='$name'")); //A logged in user made the comment - get his details.
			?>
			<wp:comment_author><![CDATA[<?php echo $name?>]]></wp:comment_author>
			<wp:comment_author_email><?php echo $email?></wp:comment_author_email>
			<wp:comment_author_IP><?php echo $ip?></wp:comment_author_IP>
			<wp:comment_date><?php echo $startdate?></wp:comment_date>
			<wp:comment_date_gmt><?php echo $startdate?></wp:comment_date_gmt>
			<wp:comment_content><![CDATA[<?php echo $comments?>]]></wp:comment_content>
			<wp:comment_approved>1</wp:comment_approved>
			<wp:comment_type></wp:comment_type>
			<wp:comment_parent>0</wp:comment_parent>
			<wp:comment_user_id>0</wp:comment_user_id>
			<?php } ?>
		</wp:comment>
		<?php } ?>
	</item>
	<?php } ?>
</channel>

<?php

/**
 * Formats the given text and return the result. For example, if 'avionics_filed_no12' is given,
 *		it will return 'Avionics Filed No 12'.
 * Argument: $value - The string that should be formated
 * Returns : The formated string
 */
function format($value) {
	$value = preg_replace(
		array(	"/_/",				//Changes 'hello_world' to 'hello world'	
				"/([a-zA-Z])(\d)/", //Changes 'no1' to 'no 1'
				"/([a-z])([A-Z])/"	//Changes 'helloWorld' to 'hello World'
		),
		array(" ","$1 $2","$1 $2"),
		$value);
	return ucwords($value);
}

/**
 * Removes all the formating from the given text and returns a string that could be used in an URL. 
 *		This fucntion lowercases the string and replaces all the special chars with '_'
 * Argument: $value - The string that should be un-formated
 * Returns : The unformated string
 */
function unformat($value) {
	$value = preg_replace('/\W/','_',$value);	//Replace all special chars with an '_'
	$value = preg_replace('/__+/','_',$value);	//Replace multiple '_' with a single one.
	$value = preg_replace(
		array('/^_/','/_$/'), //Removes the '_' towards the beginning and the end of the string.
		array('_','_'),
		$value);
	return strtolower($value);
}
